<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\AdministratoradministratorModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class AdministratoradministratorService extends BaseService
{
    /**
     AdministratoradministratorService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new AdministratoradministratorModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationGroupid()->getQuery()->select(["administratoradministrator.id as id",
			"administratoradministrator.email as email",
			"groupid.id as groupid",
			"administratoradministrator.password as password",
			"administratoradministrator.fullname as fullname",
			"administratoradministrator.img as img"]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return AdministratoradministratorModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("administratoradministrator.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return AdministratoradministratorModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		$this->model->fill($input);
		if(!$this->model->save()){
			throw new \Exception();
		}
		(new LogActivitiesService())->logingTrail($this->model);
		return $this->model;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return AdministratoradministratorModel
	*  @throws \Exception
	*/
	public function update($id,$input)
	{
		$administratoradministrator=AdministratoradministratorModel::find($id);
		$administratoradministrator->fill($input);
		if(!$administratoradministrator->update()){
			throw new \Exception();
		}
		return $administratoradministrator;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}


}